// Learn cc.Class:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/class.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/class/index.html
// Learn Attribute:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/reference/attributes/index.html
// Learn life-cycle callbacks:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/life-cycle-callbacks/index.html
 
/// 全局监听
const MyEventListener = function(obj) {
    
    let Rigister = {};
    
    obj.on = function (name, method) {
        if (!Rigister.hasOwnProperty(name)) {
            Rigister[name] = [];
        }
        Rigister[name].push(method);
    };
    
    obj.fire = function (name) {
        if (Rigister.hasOwnProperty(name)) {
            let methodList = Rigister[name];
            for (let i = 0; i < methodList.length; i++) { 
                let args = [];
                /// arguments是js默认列表，将除了参数name外的所有参数放入args数组（0是参数name）
                for (let j = 1; j < arguments.length; j++) { 
                    args.push(arguments[j]); 
                }
                methodList[i].apply(this, args);
            }
        }
    };
    
    obj.off = function (name, method) {
        if (Rigister.hasOwnProperty(name)) {
            let methodList = Rigister[name];
            for (let i = 0; i < methodList.length; i++) {
                if (methodList[i] === name) {
                    methodList.splice(i, 1);
                    break;
                } 
            }
        }
    };
    return obj;
}; 

export default MyEventListener;